## vala-panel 0.3.65

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
cmake_policy (VERSION 2.8)
project (vala-panel C)
enable_testing ()
include(GNUInstallDirs)
set (DATADIR "${CMAKE_INSTALL_FULL_DATADIR}/vala-panel")
set (DATADIR_INSTALL "${CMAKE_INSTALL_DATADIR}/vala-panel")
set (PKGDATADIR "${DATADIR}")
set (GETTEXT_PACKAGE "vala-panel")
set (RELEASE_NAME "Simple Vala panel")
set (LIBNAME "valapanel")
set (APPNAME "vala-panel")
set (SOVERSION 0)
set (PLUGINS_DIRECTORY "${CMAKE_INSTALL_FULL_LIBDIR}/vala-panel/applets/")
set (PLUGINS_DATA "${DATADIR}/applets/")
set (PLUGINS_DATA_INSTALL "${DATADIR_INSTALL}/applets")
set (PROFILES_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}/xdg/${APPNAME}")
set (PREFIX ${CMAKE_INSTALL_PREFIX})
set (DOLLAR "$")
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(GitVersion)
determine_fallback_version(${CMAKE_SOURCE_DIR}/cmake)
include(FallbackVersion)
include(Format)

# Add 'make dist' command for creating release tarball
set (CPACK_PACKAGE_VERSION ${VERSION})
set (CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
set (CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
set (CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}")
set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set (CPACK_SOURCE_IGNORE_FILES "/build/;/.git;/.gitignore;/.gitmodules;~$;${CPACK_SOURCE_IGNORE_FILES}")

# Variables for CPack binary packages
set (CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
set (CPACK_PACKAGE_RELEASE "1")
set (CPACK_PACKAGE_CONTACT "Konstantin P. <ria.freelander@gmail.com>")
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Vala Panel is GTK+ 3 desktop panel. It is based on Vala and some LXPanel ideas.")
set (CPACK_PACKAGE_DESCRIPTION "Vala Panel is GTK+ 3 desktop panel. It is based on Vala and LXPanel ideas.\nIn fact, it was be a fork of LXPanel in version 0.1.0, but in 0.2.0 it completery rewritten in Vala.\nIt offers same functionality as LXPanel, but:\n1. It has slightly more memory usage\n2. X11 dependency is stripped from panel core (but it is not tested on Wayland right now)\n3. Some of former LXPanel plugins is separate binaries now, and lives in another packages.")
set (CPACK_COMPONENTS_ALL "bin;lib;dev;plugins-base;plugins-wnck")
set (CPACK_COMPONENT_bin_DEPENDS "lib")
set (CPACK_COMPONENT_dev_DEPENDS "lib")
set (CPACK_COMPONENT_plugins-base_DEPENDS "lib")
set (CPACK_COMPONENT_plugins-wnck_DEPENDS "lib")

# Variables and functions for building deb packages
set (CPACK_DEB_COMPONENT_INSTALL ON)
set (CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set (CPACK_DEBIAN_PACKAGE_SECTION "x11")
set (CPACK_DEBIAN_PACKAGE_REVISION ${CPACK_PACKAGE_RELEASE})
string(TOLOWER "${CPACK_PACKAGE_NAME}" CPACK_PACKAGE_NAME_LOWERCASE)
find_program(DPKG_PROGRAM dpkg DOC "dpkg program of Debian-based systems")
if(DPKG_PROGRAM)
   execute_process(COMMAND ${DPKG_PROGRAM} --print-architecture
      OUTPUT_VARIABLE CPACK_DEBIAN_PACKAGE_ARCHITECTURE
      OUTPUT_STRIP_TRAILING_WHITESPACE)
   set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}-${VERSION}-${CPACK_DEBIAN_PACKAGE_REVISION}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
else(DPKG_PROGRAM)
    set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}-${VERSION}-${CPACK_DEBIAN_PACKAGE_REVISION}_${CMAKE_SYSTEM_NAME}")
endif(DPKG_PROGRAM)

# Add 'make packages' command for building Debian and RPM packages
set (CPACK_GENERATOR "DEB")
include (CPack)

#Add RPM build support
include (UseRPMTools)
if (RPMTools_FOUND)
   RPMTools_ADD_RPM_TARGETS(package ${CMAKE_SOURCE_DIR}/rpm/vala-panel.spec.in)
endif(RPMTools_FOUND)

add_custom_target (dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
# Configuration
configure_file (${CMAKE_SOURCE_DIR}/lib/config.h.in ${CMAKE_BINARY_DIR}/lib/config.h)
configure_file (${CMAKE_SOURCE_DIR}/${APPNAME}.pc.cmake ${CMAKE_BINARY_DIR}/${APPNAME}.pc)

# Some definitions
add_definitions(-DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\")

# Vala
find_package (Vala REQUIRED)
include (ValaVersion)
ensure_vala_version ("0.34" MINIMUM)
include (ValaPrecompile)

add_definitions(-DVALA_VERSION="${VALA_SHORTVER}")
#add_definitions(-w) #Suppress all GCC warnings
add_definitions(-Wall -Wno-unused # Vala loves to create variables
#		-pedantic
		-Wno-ignored-qualifiers
		-Wno-incompatible-pointer-types
		-Wno-missing-field-initializers
		-Wno-discarded-qualifiers
		-Wno-sign-compare
                -Wextra
                -fstack-protector -fstack-protector-all
                ) #Vala often forgot cast to GtkWidget or gpointer
find_package (PkgConfig)

pkg_check_modules (A
        gtk+-3.0>=3.22)

pkg_check_modules (B
  glib-2.0>=2.50)

pkg_check_modules (C
  gio-2.0>=2.50
)

pkg_check_modules (GLIB_OLD QUIET
  gio-2.0<=2.52
)

pkg_check_modules (D
  gio-unix-2.0>=2.50)

pkg_check_modules (E
  gthread-2.0>=2.50)

pkg_check_modules (F
  libpeas-1.0>=1.14)

pkg_check_modules (G
  libpeas-gtk-1.0>=1.14)

pkg_check_modules (H
  gmodule-2.0>=2.50)

pkg_check_modules (CORE REQUIRED QUIET
  gtk+-3.0>=3.22
  glib-2.0>=2.50
  gio-2.0>=2.50
  gio-unix-2.0>=2.50
  gthread-2.0>=2.50
  libpeas-1.0>=1.14
  libpeas-gtk-1.0>=1.14
  gmodule-2.0>=2.50)

set(CORE_PACKAGES
  gtk+-3.0
  glib-2.0
  gio-2.0
  gio-unix-2.0
  libpeas-1.0
  libpeas-gtk-1.0
  gmodule-2.0
  gio-addons-2.0
  posix)

set(PACKGAGE_CFLAGS ${CORE_CFLAGS})
set(PACKAGE_LINK_DIRS ${CORE_LIBRARY_DIRS})
set(PACKAGE_LIBRARIES ${CORE_LIBRARIES})

add_definitions (${CORE_CFLAGS})
link_libraries (${CORE_LIBRARIES})
link_directories (${CORE_LIBRARY_DIRS})


# Some include paths
include_directories(${CMAKE_BINARY_DIR}/lib)

#set requred variables
set(TARGET_GLIB ${GLIB_VERSION_MAJOR}.${GLIB_VERSION_MINOR})

ADD_SUBDIRECTORY(po)
ADD_SUBDIRECTORY(lib)
ADD_SUBDIRECTORY(app)
ADD_SUBDIRECTORY(runner)
ADD_SUBDIRECTORY(applets)
ADD_SUBDIRECTORY(data)

=== app/CMakeLists.txt ===
INCLUDE(GResource)
add_definitions(-DG_SETTINGS_ENABLE_BACKEND)
glib_compile_resources(GLIB_RESOURCES_APP
    source
        vala-panel.gresource.xml
)

#####
# Executable
#####
set(APP_SOURCES
        ${GLIB_RESOURCES_APP}
	vala-panel-platform-standalone-x11.c
	vala-panel-platform-standalone-x11.h
        application.c application.h)
add_executable(${APPNAME}  ${APP_SOURCES} )
target_link_libraries (${APPNAME} ${LIBNAME} ${CORE_LIBRARIES})
target_include_directories(${APPNAME} PRIVATE ${CORE_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/lib/c-lib ${CMAKE_SOURCE_DIR}/lib ${CMAKE_BINARY_DIR}/lib)

install (TARGETS ${APPNAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT bin)

=== applets/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/lib)
add_subdirectory(core)
add_subdirectory(drawing)
add_subdirectory(wnck)

=== data/CMakeLists.txt ===
add_subdirectory(gschemas)
add_subdirectory(profiles)
add_subdirectory(images)
add_subdirectory(man)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/desktop/org.valapanel.application.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/desktop/org.valapanel.application.appdata.xml DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)

=== lib/CMakeLists.txt ===
add_subdirectory(applets-new)
add_subdirectory(c-lib)
add_subdirectory(dbusmenu)
include(GLibHelpers)
set(ENUM_FILES
        panel-platform.h
        generic-config-dialog.h
        settings-manager.c
        )
add_glib_enumtypes(ENUMSC ENUMSH vala-panel-enums ${ENUM_FILES})
option(ENABLE_NEW_INTERFACE "Enable new interface function" OFF)
if (ENABLE_NEW_INTERFACE)
    set(NEW_DEFINE -D NEW)
endif()
set(LIBVALAPANEL_HEADERS
    applet-widget-api.h
    applet-widget.h
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    constants.h
    misc.h
    menu-maker.h
    css.h
    launcher.h
    generic-config-dialog.h
    settings-manager.h
    panel-platform.h
    ${ENUMSH})
set(LIBVALAPANEL_C_SOURCES
    misc.c
    menu-maker.c
    css.c
    launcher.c
    generic-config-dialog.c
    settings-manager.c
    panel-platform.c
    applet-widget.c
    ${ENUMSC})
INCLUDE(GResource)
if(GLIB_OLD_FOUND)
    list(APPEND LIBVALAPANEL_C_SOURCES
        guuid.c
        guuid.h)
endif()
set(VALA_FILES
	misc-old.vala
	configurator.vala
	applet-holder.vala
	panel-toplevel.vala
	)
vala_precompile(VALA_C ${LIBNAME}
    ${VALA_FILES}
PACKAGES
    ${CORE_PACKAGES}
    cvalapanel
OPTIONS
    --vapidir=${CMAKE_SOURCE_DIR}/vapi
    --vapidir=${CMAKE_BINARY_DIR}/vapi
    --target-glib=2.50
    --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libvalapanel.gresource.xml
    --thread
    ${NEW_DEFINE}
GENERATE_HEADER
    ${APPNAME}-compat
)

add_definitions(-DG_SETTINGS_ENABLE_BACKEND)
glib_compile_resources(GLIB_RESOURCES_LIB
    source
        libvalapanel.gresource.xml
)

#####
# Core Library
#####

# Build library for plugins and application
set (LIBS ${CORE_LIBRARIES} -lm)
set (LIB_PATHS ${CORE_LIBRARY_DIRS})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/lib)
link_directories (${LIB_PATHS})

set (LIB_FILES ${VALA_C})
add_custom_target(vala-ide-lib SOURCES ${VALA_FILES} ${CMAKE_CURRENT_SOURCE_DIR}/${APPNAME}.vapi)
add_library (${LIBNAME} SHARED
    ${LIB_FILES}
    ${LIBVALAPANEL_C_SOURCES}
    ${LIBVALAPANEL_HEADERS}
    ${GLIB_RESOURCES_LIB}
    $<TARGET_OBJECTS:vala-dbusmenu-o>
    definitions.h
)

target_link_libraries (${LIBNAME} ${LIBS})
target_include_directories(${LIBNAME} PRIVATE ${CORE_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})

set_target_properties (${LIBNAME} PROPERTIES
    VERSION ${VERSION}
    SOVERSION ${SOVERSION})

install (TARGETS ${LIBNAME} DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT bin)

# Install lib stuffs
list(APPEND LIBVALAPANEL_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/${APPNAME}-compat.h)

install (FILES ${CMAKE_BINARY_DIR}/${APPNAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/ COMPONENT dev)
install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/${APPNAME}.vapi DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/vala/vapi/ COMPONENT dev)
install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/${APPNAME}.deps DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/vala/vapi/ COMPONENT dev)
install (FILES ${LIBVALAPANEL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/vala-panel/ COMPONENT dev)

=== po/CMakeLists.txt ===
include(Translations)
add_translations_directory("vala-panel" "bin")
add_translations_catalog("vala-panel"
    ../lib
    ../app
    ../data/ui
    ../data/desktop
    ../applets
)

=== runner/CMakeLists.txt ===
INCLUDE(GResource)
set(RUNNER_SOURCES
	runner.c
	runner.h
	info-data.c
	info-data.h
	boxed-wrapper.c
	boxed-wrapper.h
	glistmodel-filter.c
	glistmodel-filter.h
	)
add_definitions(-DG_SETTINGS_ENABLE_BACKEND)
glib_compile_resources(GLIB_RESOURCES_APP
    source
        runner.gresource.xml
)

#####
# Executable
#####
add_executable(${APPNAME}-runner
	${GLIB_RESOURCES_APP}
	${RUNNER_SOURCES}
	runner-app.c
	runner-app.h
        ${CMAKE_SOURCE_DIR}/lib/css.c
        ${CMAKE_SOURCE_DIR}/lib/launcher.c)
target_link_libraries (${APPNAME}-runner ${CORE_LIBRARIES} m)
target_include_directories(${APPNAME}-runner PRIVATE ${CORE_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})
install (TARGETS ${APPNAME}-runner RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT bin)

=== applets/core/CMakeLists.txt ===
add_subdirectory(kbled)
add_subdirectory(separator)
add_subdirectory(menumodel)
add_subdirectory(clock)
add_subdirectory(dirmenu)
add_subdirectory(launchbar)

=== applets/drawing/CMakeLists.txt ===
option(ENABLE_DRAWING "Enables drawing plugins, like CPU Graph plot" ON)

if (ENABLE_DRAWING)
	add_subdirectory(cpu)
    add_subdirectory(monitors)
endif()

=== applets/wnck/CMakeLists.txt ===
include(CMakeDependentOption)
pkg_check_modules(WNCK libwnck-3.0)
pkg_check_modules(X11 x11 xcomposite xdamage xfixes gdk-x11-3.0)
cmake_dependent_option(ENABLE_X11 "Enables X11 system tray" ON
    "X11_FOUND" OFF)
cmake_dependent_option(ENABLE_WNCK "Enables wnck-related plugins, like taskbar and pager" ON
    "WNCK_FOUND;ENABLE_X11" OFF)

if (ENABLE_WNCK)
    add_subdirectory(tasklist)
    add_subdirectory(tasklist-xfce)
    add_subdirectory(pager)
    add_subdirectory(icontasks)
    add_subdirectory(deskno)
    add_subdirectory(wincmd)
    add_subdirectory(buttons)
endif()

if (ENABLE_X11)
    add_subdirectory(xembed)
endif()

=== data/gschemas/CMakeLists.txt ===
include(GSettings)
add_schema("org.valapanel.gschema.xml" "bin")
add_schema("org.valapanel.toplevel.gschema.xml" "bin")
add_schema("org.valapanel.builtin.gschema.xml" "plugins-base")
if (ENABLE_WNCK)
    add_schema("org.valapanel.X.gschema.xml" "plugins-wnck")
endif()
if (ENABLE_DRAWING)
    add_schema("org.valapanel.plugins.gschema.xml" "plugins-base")
endif()

=== data/images/CMakeLists.txt ===
install(FILES panel.svg DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps RENAME vala-panel.svg COMPONENT bin)
install(FILES background.png DESTINATION ${DATADIR_INSTALL}/images COMPONENT bin)

=== debian/changelog ===
vala-panel (0.3.65-0ubuntu1) artful; urgency=medium

  * Initial upload. (LP: #1699333)

 -- Martin Wimpress <martin.wimpress@ubuntu.com>  Sat, 15 Jul 2017 22:59:22 +0100

=== debian/control ===
Source: vala-panel
Section: x11
Priority: optional
Maintainer: Martin Wimpress <martin.wimpress@ubuntu.com>
Build-Depends: cmake (>= 2.8.0),
               debhelper (>= 10),
               docbook-to-man,
               libgtk-3-dev (>= 3.22.0),
               libpeas-dev (>= 1.2.0),
               libwnck-3-dev (>= 3.4.0),
               valac (>= 0.34.0),
Standards-Version: 4.0.0
Homepage: https://github.com/rilian-la-te/vala-panel
Vcs-Git: https://github.com/rilian-la-te/vala-project-packages.git
Vcs-Browser: https://github.com/rilian-la-te/vala-project-packages

Package: vala-panel
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: libvalapanel0 (= ${binary:Version}),
         vala-panel-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: vala-panel-plugins-base,
Suggests: vala-panel-plugins-wnck,
Description: Desktop panel written in Vala and GTK+ 3
 Vala Panel is a rewrite of SimplePanel. It is a GTK+ 3 desktop panel
 written in Vala and based on ideas from LXPanel.
 .
 Vala Panel can be extended with plugins that provide application menus,
 clock, tasklist, system tray, etc.

Package: vala-panel-common
Architecture: all
Depends: ${misc:Depends},
Description: Vala Panel - common files
 Vala Panel is a rewrite of SimplePanel. It is a GTK+ 3 desktop panel
 written in Vala and based on ideas from LXPanel.
 .
 This package provides common files.

Package: libvalapanel0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: library for Vala Panel
 Vala Panel is a rewrite of SimplePanel. It is a GTK+ 3 desktop panel
 written in Vala and based on ideas from LXPanel.
 .
 This package contains the Vala Panel library.

Package: libvalapanel-dev
Section: libdevel
Architecture: any
Depends: libvalapanel0 (= ${binary:Version}),
         ${misc:Depends},
Description: library for Vala Panel - development files
 Vala Panel is a rewrite of SimplePanel. It is a GTK+ 3 desktop panel
 written in Vala and based on ideas from LXPanel.
 .
 This package contains header files for building plugins or window
 managers with vala-panel support.

Package: vala-panel-plugins-base
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: vala-panel (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Plugins for vala-panel - non X11 plugins
 Vala Panel is a rewrite of SimplePanel. It is a GTK+ 3 desktop panel
 written in Vala and based on ideas from LXPanel.
 .
 This package contains main plugins for vala-panel: clock, launchbar,
 applications menu and so on.

Package: vala-panel-plugins-wnck
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: vala-panel (= ${binary:Version}),
         libx11-6,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Plugins for vala-panel - X11 plugins
 Vala Panel is a rewrite of SimplePanel. It is a GTK+ 3 desktop panel
 written in Vala and based on ideas from LXPanel.
 .
 This package contains X11 plugins for vala-panel: tasklist,
 system tray, and others.

=== debian/rules ===
#!/usr/bin/make -f

DHFLAGS=--buildsystem=cmake
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ $(DHFLAGS)

override_dh_auto_build:
	docbook-to-man debian/vala-panel-runner.1.sgml > debian/vala-panel-runner.1
	dh_auto_build $(DHFLAGS)

override_dh_install:
	dh_install --list-missing

override_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DGSETTINGS_COMPILE=OFF \
		-DENABLE_WNCK=ON

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://github.com/rilian-la-te/vala-panel/releases .*/vala-panel-(\d\S+)\.tar\.gz

## vala-panel 0.3.75

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-cmake_minimum_required (VERSION 2.8)
-cmake_policy (VERSION 2.8)
+cmake_minimum_required (VERSION 3.3)
+cmake_policy (VERSION 3.3)
 project (vala-panel C)
 enable_testing ()
 include(GNUInstallDirs)
@@ -72,70 +72,36 @@
 
 add_custom_target (dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
 # Configuration
-configure_file (${CMAKE_SOURCE_DIR}/lib/config.h.in ${CMAKE_BINARY_DIR}/lib/config.h)
+configure_file (${CMAKE_SOURCE_DIR}/util/config.h.in ${CMAKE_BINARY_DIR}/config.h)
 configure_file (${CMAKE_SOURCE_DIR}/${APPNAME}.pc.cmake ${CMAKE_BINARY_DIR}/${APPNAME}.pc)
 
 # Some definitions
 add_definitions(-DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\")
 
 # Vala
-find_package (Vala REQUIRED)
-include (ValaVersion)
-ensure_vala_version ("0.34" MINIMUM)
+find_package (Vala 0.34 REQUIRED)
 include (ValaPrecompile)
 
 add_definitions(-DVALA_VERSION="${VALA_SHORTVER}")
 #add_definitions(-w) #Suppress all GCC warnings
-add_definitions(-Wall -Wno-unused # Vala loves to create variables
-#		-pedantic
-		-Wno-ignored-qualifiers
-		-Wno-incompatible-pointer-types
-		-Wno-missing-field-initializers
-		-Wno-discarded-qualifiers
-		-Wno-sign-compare
-                -Wextra
-                -fstack-protector -fstack-protector-all
+add_definitions(-Wall -Wextra
+                -Wno-unused
+                -Wno-unused-parameter# Vala loves to create variables
+               #-pedantic
+                -Wno-ignored-qualifiers
+                -Wno-incompatible-pointer-types
+                -Wno-missing-field-initializers
+                -Wno-sign-compare
                 ) #Vala often forgot cast to GtkWidget or gpointer
 find_package (PkgConfig)
+find_package(GLIB2 2.50 REQUIRED COMPONENTS GOBJECT GIO GIO_UNIX GMODULE GTHREAD CODEGEN MKENUMS GENMARSHAL COMPILE_SCHEMAS COMPILE_RESOURCES)
+include(GLibProgramHandlers)
+find_package(GTK 3.22 REQUIRED COMPONENTS GDK X11 WAYLAND)
+find_package(PEAS 1.14 REQUIRED COMPONENTS PEAS)
 
-pkg_check_modules (A
-        gtk+-3.0>=3.22)
-
-pkg_check_modules (B
-  glib-2.0>=2.50)
-
-pkg_check_modules (C
-  gio-2.0>=2.50
-)
-
-pkg_check_modules (GLIB_OLD QUIET
-  gio-2.0<=2.52
-)
-
-pkg_check_modules (D
-  gio-unix-2.0>=2.50)
-
-pkg_check_modules (E
-  gthread-2.0>=2.50)
-
-pkg_check_modules (F
-  libpeas-1.0>=1.14)
-
-pkg_check_modules (G
-  libpeas-gtk-1.0>=1.14)
-
-pkg_check_modules (H
-  gmodule-2.0>=2.50)
-
-pkg_check_modules (CORE REQUIRED QUIET
-  gtk+-3.0>=3.22
-  glib-2.0>=2.50
-  gio-2.0>=2.50
-  gio-unix-2.0>=2.50
-  gthread-2.0>=2.50
-  libpeas-1.0>=1.14
-  libpeas-gtk-1.0>=1.14
-  gmodule-2.0>=2.50)
+if(GLIB2_VERSION VERSION_LESS 2.52)
+    set(GLIB_OLD_FOUND TRUE)
+endif()
 
 set(CORE_PACKAGES
   gtk+-3.0
@@ -148,24 +114,11 @@
   gio-addons-2.0
   posix)
 
-set(PACKGAGE_CFLAGS ${CORE_CFLAGS})
-set(PACKAGE_LINK_DIRS ${CORE_LIBRARY_DIRS})
-set(PACKAGE_LIBRARIES ${CORE_LIBRARIES})
-
-add_definitions (${CORE_CFLAGS})
-link_libraries (${CORE_LIBRARIES})
-link_directories (${CORE_LIBRARY_DIRS})
-
-
-# Some include paths
-include_directories(${CMAKE_BINARY_DIR}/lib)
-
-#set requred variables
-set(TARGET_GLIB ${GLIB_VERSION_MAJOR}.${GLIB_VERSION_MINOR})
 
 ADD_SUBDIRECTORY(po)
-ADD_SUBDIRECTORY(lib)
+ADD_SUBDIRECTORY(util)
+ADD_SUBDIRECTORY(runner)
+ADD_SUBDIRECTORY(ui)
 ADD_SUBDIRECTORY(app)
-ADD_SUBDIRECTORY(runner)
 ADD_SUBDIRECTORY(applets)
 ADD_SUBDIRECTORY(data)

=== app/CMakeLists.txt ===
glib_compile_resources(GLIB_RESOURCES_APP
    source
        vala-panel.gresource.xml
)

#####
# Executable
#####
set(APP_SOURCES
        ${GLIB_RESOURCES_APP}
	vala-panel-platform-standalone-x11.c
	vala-panel-platform-standalone-x11.h
        application.c application.h)
add_executable(${APPNAME}  ${APP_SOURCES} )
target_link_libraries (${APPNAME} ${LIBNAME})
target_include_directories(${APPNAME} PRIVATE
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/ui
    ${CMAKE_SOURCE_DIR}/util
    ${CMAKE_SOURCE_DIR}/util/gtk
    ${CMAKE_BINARY_DIR}/ui)

install (TARGETS ${APPNAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT bin)

=== applets/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/util ${CMAKE_SOURCE_DIR}/ui ${CMAKE_BINARY_DIR}/ui ${CMAKE_SOURCE_DIR}/util/gtk ${CMAKE_BINARY_DIR})
add_subdirectory(core)
add_subdirectory(drawing)
add_subdirectory(wnck)

=== po/CMakeLists.txt ===
include(Translations)
add_translations_directory("vala-panel" "bin")
add_translations_catalog("vala-panel"
    ../util
    ../ui
    ../app
    ../data/ui
    ../data/desktop
    ../applets
)

=== runner/CMakeLists.txt ===
INCLUDE(GLibProgramHandlers)
set(RUNNER_SOURCES
	runner.c
	runner.h
        runner-app.c
        runner-app.h
	)
add_definitions(-DG_SETTINGS_ENABLE_BACKEND)
glib_compile_resources(GLIB_RESOURCES_APP
    source
        runner.gresource.xml
)

#####
# Executable
#####
add_executable(${APPNAME}-runner
	${GLIB_RESOURCES_APP}
	${RUNNER_SOURCES})
add_dependencies(${APPNAME}-runner util-gtk)
target_link_libraries(${APPNAME}-runner util-gtk GTK3::GTK GLIB2::GIO_UNIX GLIB2::GOBJECT m)
target_include_directories(${APPNAME}-runner PRIVATE ${CMAKE_SOURCE_DIR}/util ${CMAKE_SOURCE_DIR}/util/gtk ${CMAKE_BINARY_DIR})
install (TARGETS ${APPNAME}-runner RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runner)

=== ui/CMakeLists.txt ===
add_subdirectory(applets-new)
add_subdirectory(c-lib)
set(ENUM_FILES
        panel-platform.h
        settings-manager.c
        )
add_glib_enumtypes(ENUMSC ENUMSH vala-panel-enums ${ENUM_FILES})
set(LIBVALAPANEL_HEADERS
    client.h
    server.h
    applet-widget-api.h
    applet-widget.h
    settings-manager.h
    panel-platform.h
    toplevel.h
    toplevel-config.h
    ${ENUMSH})
set(LIBVALAPANEL_C_SOURCES
    toplevel-config.c
    settings-manager.c
    panel-platform.c
    applet-widget.c
    toplevel.c
    ${ENUMSC})
set(VALA_FILES
	configurator.vala
	applet-holder.vala
	panel-layout.vala
	)
vala_precompile(VALA_C ${LIBNAME}
    ${VALA_FILES}
PACKAGES
    ${CORE_PACKAGES}
    cvalapanel
OPTIONS
    --vapidir=${CMAKE_SOURCE_DIR}/vapi
    --vapidir=${CMAKE_BINARY_DIR}/vapi
    --target-glib=2.50
    --gresources=${CMAKE_CURRENT_SOURCE_DIR}/libvalapanel.gresource.xml
    --thread
    ${NEW_DEFINE}
GENERATE_HEADER
    ${APPNAME}-compat
)

glib_compile_resources(GLIB_RESOURCES_LIB
    source
        libvalapanel.gresource.xml
)

#####
# Core Library
#####

# Build library for plugins and application
set (LIB_FILES ${VALA_C})
add_custom_target(vala-ide-lib SOURCES ${VALA_FILES} ${CMAKE_CURRENT_SOURCE_DIR}/${APPNAME}.vapi)
add_library (${LIBNAME} SHARED
    ${LIB_FILES}
    ${LIBVALAPANEL_C_SOURCES}
    ${LIBVALAPANEL_HEADERS}
    ${GLIB_RESOURCES_LIB}
    definitions.h
)

target_link_libraries (${LIBNAME} PEAS::PEAS util-gtk)
target_include_directories(${LIBNAME} PRIVATE ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/util; ${CMAKE_SOURCE_DIR}/ui ${CMAKE_SOURCE_DIR}/util/gtk)

set_target_properties (${LIBNAME} PROPERTIES
    VERSION ${VERSION}
    SOVERSION ${SOVERSION})

install (TARGETS ${LIBNAME} DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT bin)

# Install lib stuffs
list(APPEND LIBVALAPANEL_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/${APPNAME}-compat.h)

install (FILES ${CMAKE_BINARY_DIR}/${APPNAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/ COMPONENT dev)
install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/${APPNAME}.vapi DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/vala/vapi/ COMPONENT dev)
install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/${APPNAME}.deps DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/vala/vapi/ COMPONENT dev)
install (FILES ${LIBVALAPANEL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/vala-panel/ COMPONENT dev)

=== util/CMakeLists.txt ===
set(UTIL_HEADERS
    boxed-wrapper.h
    glistmodel-filter.h
    ${CMAKE_BINARY_DIR}/config.h
    constants.h
    misc.h
    info-data.h
    launcher.h
    util.h
    )
set(UTIL_SOURCES
    boxed-wrapper.c
    glistmodel-filter.c
    misc.c
    info-data.c
    launcher.c)
if(GLIB_OLD_FOUND)
    list(APPEND LIBVALAPANEL_C_SOURCES
        guuid.c
        guuid.h)
endif()
#glib_compile_resources(GLIB_RESOURCES_LIB
#    source
#        libvalapanel.gresource.xml
#)

#####
# Core Library
#####

add_library (util STATIC
    ${UTIL_SOURCES}
    ${UTIL_HEADERS}
    ${GLIB_RESOURCES_LIB}
)

target_link_libraries (util GLIB2::GIO_UNIX GLIB2::GOBJECT)
target_include_directories(util PRIVATE ${CMAKE_CURRENT_SOURCE_DIR} ${CORE_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}/util)

set_target_properties (util PROPERTIES
    VERSION ${VERSION}
    SOVERSION ${SOVERSION}
    POSITION_INDEPENDENT_CODE ON)

add_subdirectory(gtk)

install (FILES ${UTIL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/vala-panel/ COMPONENT dev)

=== applets/wnck/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include(CMakeDependentOption)
-pkg_check_modules(WNCK libwnck-3.0)
-pkg_check_modules(X11 x11 xcomposite xdamage xfixes gdk-x11-3.0)
+find_package(WNCK 3.4.8)
+find_package(X11 COMPONENTS X11 Xcomposite Xdamage Xrender Xfixes)
 cmake_dependent_option(ENABLE_X11 "Enables X11 system tray" ON
     "X11_FOUND" OFF)
 cmake_dependent_option(ENABLE_WNCK "Enables wnck-related plugins, like taskbar and pager" ON

=== ui/applets-new/CMakeLists.txt ===
include(GLibProgramHandlers)
add_glib_marshal(MARSHALS MARSHALH "applet-api-marshal" g_cclosure_user_marshal)
add_library(applet-api-new SHARED
        applet-info.c
        applet-engine.c
        applet-api.h
        ${MARSHALS}
        ${ENUMSC}
        ${ENUMSH}
        ${MARSHALH}
	)
target_link_libraries (applet-api-new GLIB2::GOBJECT GLIB2::GIO_UNIX GTK3::GDK GTK3::GTK)
target_include_directories(applet-api-new PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/ui)
set_target_properties (applet-api-new PROPERTIES
    VERSION ${VERSION}
    SOVERSION ${SOVERSION})
#install (TARGETS applet-api-new DESTINATION ${CMAKE_INSTALL_LIBDIR}/${CMAKE_PROJECT_NAME}/ COMPONENT bin)

=== ui/c-lib/CMakeLists.txt ===
include(GLibProgramHandlers)
set(ENUM_FILES
        toplevel.h
        panel-layout.h
        )
add_glib_enumtypes(ENUMSC ENUMSH vala-panel-enums ${ENUM_FILES})
add_library(cvalapanel SHARED
    panel-layout.h
    panel-layout.c
    applet-manager.c
    applet-engine-module.c
    private.h)
target_link_libraries (cvalapanel GLIB2::GOBJECT GLIB2::GIO_UNIX GTK3::GDK GTK3::GTK)
target_include_directories(cvalapanel PRIVATE
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/ui
    ${CMAKE_SOURCE_DIR}/util
    ${CMAKE_SOURCE_DIR}/ui/applets-new)
set_target_properties (cvalapanel PROPERTIES
    VERSION ${VERSION}
    SOVERSION ${SOVERSION})
#install (TARGETS cvalapanel DESTINATION ${CMAKE_INSTALL_LIBDIR}/${CMAKE_PROJECT_NAME}/ COMPONENT bin)

=== applets/core/clock/CMakeLists.txt ===
set(PLUGIN_NAME clock)
set(VALA_FILES ${PLUGIN_NAME}.vala)
vala_precompile(VALA_C ${PLUGIN_NAME}
    ${VALA_FILES}
PACKAGES
    ${CORE_PACKAGES}
    vala-panel
OPTIONS
    --vapidir=${CMAKE_SOURCE_DIR}/vapi
    --vapidir=${CMAKE_SOURCE_DIR}/ui
    --vapidir=${CMAKE_BINARY_DIR}/vapi
    --target-glib=2.50
    --gresources=${CMAKE_CURRENT_SOURCE_DIR}/${PLUGIN_NAME}.gresource.xml
    --thread
)
#####
# Plugin Library
#####

# Build library for plugin
add_library (${PLUGIN_NAME} MODULE
    ${VALA_C}
    ${RESOURCES}
)
target_link_libraries (${PLUGIN_NAME} valapanel)
add_custom_target(vala-ide-${PLUGIN_NAME} SOURCES ${VALA_FILES})

# Install plugin stuffs
install(TARGETS ${PLUGIN_NAME} DESTINATION ${PLUGINS_DIRECTORY} COMPONENT plugins-base)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PLUGIN_NAME}.plugin DESTINATION ${PLUGINS_DIRECTORY} COMPONENT plugins-base)

=== applets/core/dirmenu/CMakeLists.txt ===
set(PLUGIN_NAME dirmenu)
set(VALA_FILES ${PLUGIN_NAME}.vala)
vala_precompile(VALA_C ${PLUGIN_NAME}
    ${VALA_FILES}
PACKAGES
    ${CORE_PACKAGES}
    vala-panel
OPTIONS
    --vapidir=${CMAKE_SOURCE_DIR}/vapi
    --vapidir=${CMAKE_SOURCE_DIR}/ui
    --vapidir=${CMAKE_BINARY_DIR}/vapi
    --target-glib=2.50
    --gresources=${CMAKE_CURRENT_SOURCE_DIR}/${PLUGIN_NAME}.gresource.xml
    --thread
)
#####
# Plugin Library
#####

# Build library for plugin
add_library (${PLUGIN_NAME} MODULE
    ${VALA_C}
    ${RESOURCES}
)

target_link_libraries (${PLUGIN_NAME} valapanel)
add_custom_target(vala-ide-${PLUGIN_NAME} SOURCES ${VALA_FILES})

# Install plugin stuffs
install(TARGETS ${PLUGIN_NAME} DESTINATION ${PLUGINS_DIRECTORY} COMPONENT plugins-base)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PLUGIN_NAME}.plugin DESTINATION ${PLUGINS_DIRECTORY} COMPONENT plugins-base)

=== debian/changelog ===
vala-panel (0.3.75-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 01 Jul 2018 13:27:38 -0700

vala-panel (0.3.75-1) unstable; urgency=medium

  * New upstream release.
  * debian/libvalapanel0.symbols:
    + Update symbols file.
  * debian/control:
    + Bump Standards-Version: to 4.1.4. No changes needed.
  * debian/copyright:
    + Use secure URI to obtain copyright format reference.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 24 Apr 2018 11:27:05 +0200

vala-panel (0.3.74-1) unstable; urgency=medium

  * New upstream release.
  * debian/libvalapanel0.symbols:
    + Update symbols files (dbus_menu_* removed).
  * debian/copyright:
    + Update copyright attributions.
  * debian/control:
    + Add B (libvalapanel0): vala-panel-appmenu (<< 0.6.80)

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 15 Feb 2018 21:51:17 +0100

vala-panel (0.3.73-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Add auto-generated copyright.in file for tracking upstream licensing
      changes.
    + Update copyright attributions.
  * debian/libvalapanel0.symbols:
    + Update symbols file.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 23 Jan 2018 03:18:06 +0100

vala-panel (0.3.71-1) unstable; urgency=medium

  [ Martin Wimpress]
  * Initial release to Debian. (Closes: #887675).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 19 Jan 2018 01:06:08 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,26 @@
 Source: vala-panel
 Section: x11
 Priority: optional
-Maintainer: Martin Wimpress <martin.wimpress@ubuntu.com>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Ayatana Packagers <pkg-ayatana-devel@lists.alioth.debian.org>
+Uploaders:
+ Debian+Ubuntu MATE Packaging Team <debian-mate@lists.debian.org>,
+ Martin Wimpress <martin.wimpress@ubuntu.com>,
+ Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cmake (>= 2.8.0),
-               debhelper (>= 10),
+               debhelper (>= 11~),
                docbook-to-man,
                libgtk-3-dev (>= 3.22.0),
                libpeas-dev (>= 1.2.0),
                libwnck-3-dev (>= 3.4.0),
                valac (>= 0.34.0),
-Standards-Version: 4.0.0
+Standards-Version: 4.1.4
 Homepage: https://github.com/rilian-la-te/vala-panel
-Vcs-Git: https://github.com/rilian-la-te/vala-project-packages.git
-Vcs-Browser: https://github.com/rilian-la-te/vala-project-packages
+Vcs-Git: https://anonscm.debian.org/git/pkg-ayatana/vala-panel.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ayatana/vala-panel.git
 
 Package: vala-panel
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends},
 Depends: libvalapanel0 (= ${binary:Version}),
          vala-panel-common (= ${source:Version}),
          ${misc:Depends},
@@ -44,6 +48,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
+Breaks: vala-panel-appmenu (<< 0.6.80),
 Description: library for Vala Panel
  Vala Panel is a rewrite of SimplePanel. It is a GTK+ 3 desktop panel
  written in Vala and based on ideas from LXPanel.
@@ -68,7 +73,7 @@
 Depends: vala-panel (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
-Description: Plugins for vala-panel - non X11 plugins
+Description: Plugins for vala-panel - non-X11 plugins
  Vala Panel is a rewrite of SimplePanel. It is a GTK+ 3 desktop panel
  written in Vala and based on ideas from LXPanel.
  .

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 DHFLAGS=--buildsystem=cmake
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+include /usr/share/dpkg/buildflags.mk
 
 %:
 	dh $@ $(DHFLAGS)
